package nl.kallestruik.riseofblocks.mixin;

import net.minecraft.core.registries.BuiltInRegistries;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.level.block.Block;
import nl.kallestruik.riseofblocks.BlastResistanceOverrideConfig;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(Block.class)
public class BlockMixin {
    @Inject(method = "getExplosionResistance", at = @At("HEAD"), cancellable = true)
    private void overrideExplosionResistance(CallbackInfoReturnable<Float> cir) {
        Block self = (Block) (Object) this;
        ResourceLocation id = BuiltInRegistries.BLOCK.getKey(self);

        if (BlastResistanceOverrideConfig.hasCustomResistance(id)) {
            Float newResistance = BlastResistanceOverrideConfig.getResistance(id);
            cir.setReturnValue(newResistance);
        }
    }
}